/[gentoo-x86]/eclass/haskell-cabal.eclass
Gentoo

Contents of /eclass/haskell-cabal.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.29 - (show annotations) (download)
Mon Apr 9 18:08:45 2012 UTC (2 years, 6 months ago) by slyfox
Branch: MAIN
Changes since 1.28: +57 -115 lines
Remove outdated bits for <ghc-6.10 and <cabal-1.8. Switch from 'eerror' to 'eqawarn' as suggested by PaweĊ‚ Hajdan, Jr. (http://www.gossamer-threads.com/lists/gentoo/dev/251259). Install empty '.conf' files for binaries to help 'haskell-updater' pick binaries built with onder haskell toolchain on ghc upgrade.

1 # Copyright 1999-2012 Gentoo Foundation
2 # Distributed under the terms of the GNU General Public License v2
3 # $Header: /var/cvsroot/gentoo-x86/eclass/haskell-cabal.eclass,v 1.28 2012/03/09 22:01:11 slyfox Exp $
4
5 # @ECLASS: haskell-cabal.eclass
6 # @MAINTAINER:
7 # Haskell herd <haskell@gentoo.org>
8 # @AUTHOR:
9 # Original author: Andres Loeh <kosmikus@gentoo.org>
10 # Original author: Duncan Coutts <dcoutts@gentoo.org>
11 # @BLURB: for packages that make use of the Haskell Common Architecture for Building Applications and Libraries (cabal)
12 # @DESCRIPTION:
13 # Basic instructions:
14 #
15 # Before inheriting the eclass, set CABAL_FEATURES to
16 # reflect the tools and features that the package makes
17 # use of.
18 #
19 # Currently supported features:
20 # haddock -- for documentation generation
21 # hscolour -- generation of colourised sources
22 # alex -- lexer/scanner generator
23 # happy -- parser generator
24 # c2hs -- C interface generator
25 # cpphs -- C preprocessor clone written in Haskell
26 # profile -- if package supports to build profiling-enabled libraries
27 # bootstrap -- only used for the cabal package itself
28 # bin -- the package installs binaries
29 # lib -- the package installs libraries
30 # nocabaldep -- don't add dependency on cabal.
31 # only used for packages that _must_ not pull the dependency
32 # on cabal, but still use this eclass (e.g. haskell-updater).
33
34 inherit ghc-package multilib
35
36 # @ECLASS-VARIABLE: CABAL_EXTRA_CONFIGURE_FLAGS
37 # @DESCRIPTION:
38 # User-specified additional parameters passed to 'setup configure'.
39 # example: /etc/make.conf: CABAL_EXTRA_CONFIGURE_FLAGS=--enable-shared
40 : ${CABAL_EXTRA_CONFIGURE_FLAGS:=}
41
42 # @ECLASS-VARIABLE: CABAL_EXTRA_BUILD_FLAGS
43 # @DESCRIPTION:
44 # User-specified additional parameters passed to 'setup build'.
45 # example: /etc/make.conf: CABAL_EXTRA_BUILD_FLAGS=-v
46 : ${CABAL_EXTRA_BUILD_FLAGS:=}
47
48 # @ECLASS-VARIABLE: GHC_BOOTSTRAP_FLAGS
49 # @DESCRIPTION:
50 # User-specified additional parameters for ghc when building
51 # _only_ 'setup' binary bootstrap.
52 # example: /etc/make.conf: GHC_BOOTSTRAP_FLAGS=-dynamic to make
53 # linking 'setup' faster.
54 : ${GHC_BOOTSTRAP_FLAGS:=}
55
56 HASKELL_CABAL_EXPF="pkg_setup src_compile src_test src_install"
57
58 case "${EAPI:-0}" in
59 2|3|4) HASKELL_CABAL_EXPF+=" src_configure" ;;
60 *) ;;
61 esac
62
63 EXPORT_FUNCTIONS ${HASKELL_CABAL_EXPF}
64
65 for feature in ${CABAL_FEATURES}; do
66 case ${feature} in
67 haddock) CABAL_USE_HADDOCK=yes;;
68 hscolour) CABAL_USE_HSCOLOUR=yes;;
69 hoogle) CABAL_USE_HOOGLE=yes;;
70 alex) CABAL_USE_ALEX=yes;;
71 happy) CABAL_USE_HAPPY=yes;;
72 c2hs) CABAL_USE_C2HS=yes;;
73 cpphs) CABAL_USE_CPPHS=yes;;
74 profile) CABAL_USE_PROFILE=yes;;
75 bootstrap) CABAL_BOOTSTRAP=yes;;
76 bin) CABAL_HAS_BINARIES=yes;;
77 lib) CABAL_HAS_LIBRARIES=yes;;
78 nocabaldep) CABAL_FROM_GHC=yes;;
79 *) CABAL_UNKNOWN="${CABAL_UNKNOWN} ${feature}";;
80 esac
81 done
82
83 if [[ -n "${CABAL_USE_HADDOCK}" ]]; then
84 IUSE="${IUSE} doc"
85 # don't require depend on itself to build docs.
86 # ebuild bootstraps docs from just built binary
87 [[ ${CATEGORY}/${PN} = "dev-haskell/haddock" ]] || DEPEND="${DEPEND} doc? ( dev-haskell/haddock )"
88 fi
89
90 if [[ -n "${CABAL_USE_HSCOLOUR}" ]]; then
91 IUSE="${IUSE} hscolour"
92 DEPEND="${DEPEND} hscolour? ( dev-haskell/hscolour )"
93 fi
94
95 if [[ -n "${CABAL_USE_ALEX}" ]]; then
96 DEPEND="${DEPEND} dev-haskell/alex"
97 fi
98
99 if [[ -n "${CABAL_USE_HAPPY}" ]]; then
100 DEPEND="${DEPEND} dev-haskell/happy"
101 fi
102
103 if [[ -n "${CABAL_USE_C2HS}" ]]; then
104 DEPEND="${DEPEND} dev-haskell/c2hs"
105 fi
106
107 if [[ -n "${CABAL_USE_CPPHS}" ]]; then
108 DEPEND="${DEPEND} dev-haskell/cpphs"
109 fi
110
111 if [[ -n "${CABAL_USE_PROFILE}" ]]; then
112 IUSE="${IUSE} profile"
113 fi
114
115 # We always use a standalone version of Cabal, rather than the one that comes
116 # with GHC. But of course we can't depend on cabal when building cabal itself.
117 if [[ -z ${CABAL_MIN_VERSION} ]]; then
118 CABAL_MIN_VERSION=1.1.4
119 fi
120 if [[ -z "${CABAL_BOOTSTRAP}" && -z "${CABAL_FROM_GHC}" ]]; then
121 DEPEND="${DEPEND} >=dev-haskell/cabal-${CABAL_MIN_VERSION}"
122 fi
123
124 # Libraries require GHC to be installed.
125 if [[ -n "${CABAL_HAS_LIBRARIES}" ]]; then
126 RDEPEND="${RDEPEND} dev-lang/ghc"
127 fi
128
129 # returns the version of cabal currently in use
130 _CABAL_VERSION_CACHE=""
131 cabal-version() {
132 if [[ -z "${_CABAL_VERSION_CACHE}" ]]; then
133 if [[ "${CABAL_BOOTSTRAP}" ]]; then
134 # We're bootstrapping cabal, so the cabal version is the version
135 # of this package itself.
136 _CABAL_VERSION_CACHE="${PV}"
137 elif [[ "${CABAL_FROM_GHC}" ]]; then
138 local cabal_package=$(echo "$(ghc-libdir)"/Cabal-*)
139 # /path/to/ghc/Cabal-${VER} -> ${VER}
140 _CABAL_VERSION_CACHE="${cabal_package/*Cabal-/}"
141 else
142 # We ask portage, not ghc, so that we only pick up
143 # portage-installed cabal versions.
144 _CABAL_VERSION_CACHE="$(ghc-extractportageversion dev-haskell/cabal)"
145 fi
146 fi
147 echo "${_CABAL_VERSION_CACHE}"
148 }
149
150 cabal-bootstrap() {
151 local setupmodule
152 local cabalpackage
153 if [[ -f "${S}/Setup.lhs" ]]; then
154 setupmodule="${S}/Setup.lhs"
155 elif [[ -f "${S}/Setup.hs" ]]; then
156 setupmodule="${S}/Setup.hs"
157 else
158 die "No Setup.lhs or Setup.hs found"
159 fi
160
161 # We build the setup program using the latest version of
162 # cabal that we have installed
163 cabalpackage=Cabal-$(cabal-version)
164 einfo "Using cabal-$(cabal-version)."
165
166 make_setup() {
167 set -- -package "${cabalpackage}" --make "${setupmodule}" \
168 ${GHC_BOOTSTRAP_FLAGS} \
169 "$@" \
170 -o setup
171 echo $(ghc-getghc) ${HCFLAGS} "$@"
172 $(ghc-getghc) "$@"
173 }
174 if $(ghc-supports-shared-libraries); then
175 # some custom build systems might use external libraries,
176 # for which we don't have shared libs, so keep static fallback
177 make_setup -dynamic "$@" || make_setup "$@" || die "compiling ${setupmodule} failed"
178 else
179 make_setup "$@" || die "compiling ${setupmodule} failed"
180 fi
181 }
182
183 cabal-mksetup() {
184 local setupdir
185
186 if [[ -n $1 ]]; then
187 setupdir=$1
188 else
189 setupdir=${S}
190 fi
191
192 rm -f "${setupdir}"/Setup.{lhs,hs}
193
194 echo 'import Distribution.Simple; main = defaultMainWithHooks defaultUserHooks' \
195 > $setupdir/Setup.hs || die "failed to create default Setup.hs"
196 }
197
198 cabal-hscolour() {
199 set -- hscolour "$@"
200 echo ./setup "$@"
201 ./setup "$@" || die "setup hscolour failed"
202 }
203
204 cabal-haddock() {
205 set -- haddock "$@"
206 echo ./setup "$@"
207 ./setup "$@" || die "setup haddock failed"
208 }
209
210 cabal-hscolour-haddock() {
211 # --hyperlink-source implies calling 'setup hscolour'
212 set -- haddock --hyperlink-source
213 echo ./setup "$@"
214 ./setup "$@" --hyperlink-source || die "setup haddock --hyperlink-source failed"
215 }
216
217 cabal-configure() {
218 has "${EAPI:-0}" 0 1 2 && ! use prefix && EPREFIX=
219
220 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then
221 cabalconf="${cabalconf} --with-haddock=${EPREFIX}/usr/bin/haddock"
222 fi
223 if [[ -n "${CABAL_USE_PROFILE}" ]] && use profile; then
224 cabalconf="${cabalconf} --enable-library-profiling"
225 fi
226 if [[ -n "${CABAL_USE_ALEX}" ]]; then
227 cabalconf="${cabalconf} --with-alex=${EPREFIX}/usr/bin/alex"
228 fi
229
230 if [[ -n "${CABAL_USE_HAPPY}" ]]; then
231 cabalconf="${cabalconf} --with-happy=${EPREFIX}/usr/bin/happy"
232 fi
233
234 if [[ -n "${CABAL_USE_C2HS}" ]]; then
235 cabalconf="${cabalconf} --with-c2hs=${EPREFIX}/usr/bin/c2hs"
236 fi
237 if [[ -n "${CABAL_USE_CPPHS}" ]]; then
238 cabalconf="${cabalconf} --with-cpphs=${EPREFIX}/usr/bin/cpphs"
239 fi
240
241 local option
242 for option in ${HCFLAGS}
243 do
244 cabalconf+=" --ghc-option=$option"
245 done
246
247 # Building GHCi libs on ppc64 causes "TOC overflow".
248 if use ppc64; then
249 cabalconf="${cabalconf} --disable-library-for-ghci"
250 fi
251
252 # currently cabal does not respect CFLAGS and LDFLAGS on it's own (bug #333217)
253 # so translate LDFLAGS to ghc parameters (without filtering)
254 local flag
255 for flag in $LDFLAGS; do cabalconf="${cabalconf} --ghc-option=-optl$flag"; done
256
257 # disable executable stripping for the executables, as portage will
258 # strip by itself, and pre-stripping gives a QA warning.
259 # cabal versions previous to 1.4 does not strip executables, and does
260 # not accept the flag.
261 # this fixes numerous bugs, amongst them;
262 # bug #251881, bug #251882, bug #251884, bug #251886, bug #299494
263 cabalconf="${cabalconf} --disable-executable-stripping"
264
265 cabalconf="${cabalconf} --docdir=${EPREFIX}/usr/share/doc/${PF}"
266 # As of Cabal 1.2, configure is quite quiet. For diagnostic purposes
267 # it's better if the configure chatter is in the build logs:
268 cabalconf="${cabalconf} --verbose"
269
270 # We build shared version of our Cabal where ghc ships it's shared
271 # version of it. We will link ./setup as dynamic binary againt Cabal later.
272 [[ ${CATEGORY}/${PN} == "dev-haskell/cabal" ]] && \
273 $(ghc-supports-shared-libraries) && \
274 cabalconf="${cabalconf} --enable-shared"
275
276 set -- configure \
277 --ghc --prefix="${EPREFIX}"/usr \
278 --with-compiler="$(ghc-getghc)" \
279 --with-hc-pkg="$(ghc-getghcpkg)" \
280 --prefix="${EPREFIX}"/usr \
281 --libdir="${EPREFIX}"/usr/$(get_libdir) \
282 --libsubdir=${P}/ghc-$(ghc-version) \
283 --datadir="${EPREFIX}"/usr/share/ \
284 --datasubdir=${P}/ghc-$(ghc-version) \
285 ${cabalconf} \
286 ${CABAL_CONFIGURE_FLAGS} \
287 ${CABAL_EXTRA_CONFIGURE_FLAGS} \
288 "$@"
289 echo ./setup "$@"
290 ./setup "$@" || die "setup configure failed"
291 }
292
293 cabal-build() {
294 unset LANG LC_ALL LC_MESSAGES
295 set -- build ${CABAL_EXTRA_BUILD_FLAGS} "$@"
296 echo ./setup "$@"
297 ./setup "$@" \
298 || die "setup build failed"
299 }
300
301 cabal-copy() {
302 has "${EAPI:-0}" 0 1 2 && ! use prefix && ED=${D}
303
304 set -- copy --destdir="${D}" "$@"
305 echo ./setup "$@"
306 ./setup "$@" || die "setup copy failed"
307
308 # cabal is a bit eager about creating dirs,
309 # so remove them if they are empty
310 rmdir "${ED}/usr/bin" 2> /dev/null
311 }
312
313 cabal-pkg() {
314 # This does not actually register since we're using true instead
315 # of ghc-pkg. So it just leaves the .conf file and we can
316 # register that ourselves (if it exists).
317
318 if [[ -n ${CABAL_HAS_LIBRARIES} ]]; then
319 # Newer cabal can generate a package conf for us:
320 ./setup register --gen-pkg-config="${T}/${P}.conf"
321 ghc-setup-pkg "${T}/${P}.conf"
322 ghc-install-pkg
323 fi
324 }
325
326 # Some cabal libs are bundled along with some versions of ghc
327 # eg filepath-1.0 comes with ghc-6.6.1
328 # by putting CABAL_CORE_LIB_GHC_PV="6.6.1" in an ebuild we are declaring that
329 # when building with this version of ghc, the ebuild is a dummy that is it will
330 # install no files since the package is already included with ghc.
331 # However portage still records the dependency and we can upgrade the package
332 # to a later one that's not included with ghc.
333 # You can also put a space separated list, eg CABAL_CORE_LIB_GHC_PV="6.6 6.6.1".
334 cabal-is-dummy-lib() {
335 for version in ${CABAL_CORE_LIB_GHC_PV[*]}; do
336 [[ "$(ghc-version)" == "$version" ]] && return 0
337 done
338 return 1
339 }
340
341 # exported function: check if cabal is correctly installed for
342 # the currently active ghc (we cannot guarantee this with portage)
343 haskell-cabal_pkg_setup() {
344 if [[ -z "${CABAL_BOOTSTRAP}" && -z "${CABAL_FROM_GHC}" ]] && ! ghc-sanecabal "${CABAL_MIN_VERSION}"; then
345 eerror "The package dev-haskell/cabal is not correctly installed for"
346 eerror "the currently active version of ghc ($(ghc-version)). Please"
347 eerror "run haskell-updater or re-build dev-haskell/cabal."
348 die "cabal is not correctly installed"
349 fi
350 if [[ -z "${CABAL_HAS_BINARIES}" ]] && [[ -z "${CABAL_HAS_LIBRARIES}" ]]; then
351 eqawarn "QA Notice: Neither bin nor lib are in CABAL_FEATURES."
352 fi
353 if [[ -n "${CABAL_UNKNOWN}" ]]; then
354 eqawarn "QA Notice: Unknown entry in CABAL_FEATURES: ${CABAL_UNKNOWN}"
355 fi
356 if cabal-is-dummy-lib; then
357 einfo "${P} is included in ghc-${CABAL_CORE_LIB_GHC_PV}, nothing to install."
358 fi
359 }
360
361 haskell-cabal_src_configure() {
362 cabal-is-dummy-lib && return
363
364 pushd "${S}" > /dev/null
365
366 cabal-bootstrap
367
368 cabal-configure "$@"
369
370 popd > /dev/null
371 }
372
373 # exported function: nice alias
374 cabal_src_configure() {
375 haskell-cabal_src_configure "$@"
376 }
377
378 # exported function: cabal-style bootstrap configure and compile
379 cabal_src_compile() {
380 # it's a common mistake when one bumps ebuild to EAPI="2" (and upper)
381 # and forgets to separate src_compile() to src_configure()/src_compile().
382 # Such error leads to default src_configure and we lose all passed flags.
383 if ! has "${EAPI:-0}" 0 1; then
384 local passed_flag
385 for passed_flag in "$@"; do
386 [[ ${passed_flag} == --flags=* ]] && \
387 eqawarn "QA Notice: Cabal option '${passed_flag}' has effect only in src_configure()"
388 done
389 fi
390
391 cabal-is-dummy-lib && return
392
393 has src_configure ${HASKELL_CABAL_EXPF} || haskell-cabal_src_configure "$@"
394 cabal-build
395
396 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then
397 if [[ -n "${CABAL_USE_HSCOLOUR}" ]] && use hscolour; then
398 # hscolour and haddock
399 cabal-hscolour-haddock
400 else
401 # just haddock
402 cabal-haddock
403 fi
404 else
405 if [[ -n "${CABAL_USE_HSCOLOUR}" ]] && use hscolour; then
406 # just hscolour
407 cabal-hscolour
408 fi
409 fi
410 }
411
412 haskell-cabal_src_compile() {
413 pushd "${S}" > /dev/null
414
415 cabal_src_compile "$@"
416
417 popd > /dev/null
418 }
419
420 haskell-cabal_src_test() {
421 pushd "${S}" > /dev/null
422
423 if cabal-is-dummy-lib; then
424 einfo ">>> No tests for dummy library: ${CATEGORY}/${PF}"
425 else
426 einfo ">>> Test phase [cabal test]: ${CATEGORY}/${PF}"
427 set -- test "$@"
428 echo ./setup "$@"
429 ./setup "$@" || die "cabal test failed"
430 fi
431
432 popd > /dev/null
433 }
434
435 # exported function: cabal-style copy and register
436 cabal_src_install() {
437 has "${EAPI:-0}" 0 1 2 && ! use prefix && EPREFIX=
438
439 if ! cabal-is-dummy-lib; then
440 cabal-copy
441 cabal-pkg
442 fi
443
444 # create a dummy local package conf file for haskell-updater
445 # if it does not exist (dummy libraries and binaries w/o libraries)
446 local ghc_confdir_with_prefix="$(ghc-confdir)"
447 # remove EPREFIX
448 dodir ${ghc_confdir_with_prefix#${EPREFIX}}
449 local conf_file="${D}/$(ghc-confdir)/$(ghc-localpkgconf)"
450 [[ -e $conf_file ]] || echo '[]' > "$conf_file" || die
451 }
452
453 haskell-cabal_src_install() {
454 pushd "${S}" > /dev/null
455
456 cabal_src_install
457
458 popd > /dev/null
459 }
460
461 # ebuild.sh:use_enable() taken as base
462 #
463 # Usage examples:
464 #
465 # CABAL_CONFIGURE_FLAGS=$(cabal_flag gui)
466 # leads to "--flags=gui" or "--flags=-gui" (useflag 'gui')
467 #
468 # CABAL_CONFIGURE_FLAGS=$(cabal_flag gtk gui)
469 # also leads to "--flags=gui" or " --flags=-gui" (useflag 'gtk')
470 #
471 cabal_flag() {
472 if [[ -z "$1" ]]; then
473 echo "!!! cabal_flag() called without a parameter." >&2
474 echo "!!! cabal_flag() <USEFLAG> [<cabal_flagname>]" >&2
475 return 1
476 fi
477
478 local UWORD=${2:-$1}
479
480 if use "$1"; then
481 echo "--flags=${UWORD}"
482 else
483 echo "--flags=-${UWORD}"
484 fi
485
486 return 0
487 }

  ViewVC Help
Powered by ViewVC 1.1.20